#include <SDL.h>
#include <SDL_opengl.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include "gl_kanji.h"



ist::glKanji kanji;
char text[10][128];


void draw_edged_font(int x, int y, const char *str)
{
	glColor3ub( 0, 0, 0 );
	kanji.print(x+1, y, str);
	kanji.print(x-1, y, str);
	kanji.print(x, y+1, str);
	kanji.print(x, y-1, str);

	glColor3ub( 255, 255, 255 );
	kanji.print(x, y, str);
}


void draw()
{
	// SDL̃hLgɍڂĂTvہX]
	static float angle = 0.0f;
	static GLfloat v0[] = { -1.0f, -1.0f,  1.0f };
	static GLfloat v1[] = {  1.0f, -1.0f,  1.0f };
	static GLfloat v2[] = {  1.0f,  1.0f,  1.0f };
	static GLfloat v3[] = { -1.0f,  1.0f,  1.0f };
	static GLfloat v4[] = { -1.0f, -1.0f, -1.0f };
	static GLfloat v5[] = {  1.0f, -1.0f, -1.0f };
	static GLfloat v6[] = {  1.0f,  1.0f, -1.0f };
	static GLfloat v7[] = { -1.0f,  1.0f, -1.0f };
	static GLubyte red[]    = { 255,   0,   0, 255 };
	static GLubyte green[]  = {   0, 255,   0, 255 };
	static GLubyte blue[]   = {   0,   0, 255, 255 };
	static GLubyte white[]  = { 255, 255, 255, 255 };
	static GLubyte yellow[] = {   0, 255, 255, 255 };
	static GLubyte black[]  = {   0,   0,   0, 255 };
	static GLubyte orange[] = { 255, 255,   0, 255 };
	static GLubyte purple[] = { 255,   0, 255,   0 };


	glClear(GL_COLOR_BUFFER_BIT);

	glMatrixMode( GL_MODELVIEW );
	glLoadIdentity( );

	glTranslatef( 0.0, 0.0, -5.0 );
	glRotatef( angle, 0.0, 1.0, 0.0 );

	if( ++angle > 360.0f ) {
		angle = 0.0f;
	}

	glBegin( GL_TRIANGLES );

	glColor4ubv( red );
	glVertex3fv( v0 );
	glColor4ubv( green );
	glVertex3fv( v1 );
	glColor4ubv( blue );
	glVertex3fv( v2 );

	glColor4ubv( red );
	glVertex3fv( v0 );
	glColor4ubv( blue );
	glVertex3fv( v2 );
	glColor4ubv( white );
	glVertex3fv( v3 );

	glColor4ubv( green );
	glVertex3fv( v1 );
	glColor4ubv( black );
	glVertex3fv( v5 );
	glColor4ubv( orange );
	glVertex3fv( v6 );

	glColor4ubv( green );
	glVertex3fv( v1 );
	glColor4ubv( orange );
	glVertex3fv( v6 );
	glColor4ubv( blue );
	glVertex3fv( v2 );

	glColor4ubv( black );
	glVertex3fv( v5 );
	glColor4ubv( yellow );
	glVertex3fv( v4 );
	glColor4ubv( purple );
	glVertex3fv( v7 );

	glColor4ubv( black );
	glVertex3fv( v5 );
	glColor4ubv( purple );
	glVertex3fv( v7 );
	glColor4ubv( orange );
	glVertex3fv( v6 );

	glColor4ubv( yellow );
	glVertex3fv( v4 );
	glColor4ubv( red );
	glVertex3fv( v0 );
	glColor4ubv( white );
	glVertex3fv( v3 );

	glColor4ubv( yellow );
	glVertex3fv( v4 );
	glColor4ubv( white );
	glVertex3fv( v3 );
	glColor4ubv( purple );
	glVertex3fv( v7 );

	glColor4ubv( white );
	glVertex3fv( v3 );
	glColor4ubv( blue );
	glVertex3fv( v2 );
	glColor4ubv( orange );
	glVertex3fv( v6 );

	glColor4ubv( white );
	glVertex3fv( v3 );
	glColor4ubv( orange );
	glVertex3fv( v6 );
	glColor4ubv( purple );
	glVertex3fv( v7 );

	glColor4ubv( green );
	glVertex3fv( v1 );
	glColor4ubv( red );
	glVertex3fv( v0 );
	glColor4ubv( yellow );
	glVertex3fv( v4 );

	glColor4ubv( green );
	glVertex3fv( v1 );
	glColor4ubv( yellow );
	glVertex3fv( v4 );
	glColor4ubv( black );
	glVertex3fv( v5 );

	glEnd( );


	glColor3ub( 255, 255, 255 );
	static int pre_fps, cur_fps, pre_sec;
	int cur_sec = time(0);

	++cur_fps;
	if(pre_sec!=cur_sec) {
		pre_sec = cur_sec;
		pre_fps = cur_fps;
		cur_fps = 0;
	}

	char buf[128];
	sprintf(buf, "FPS:%d", pre_fps);
	draw_edged_font(5, 5, buf);

	for(int i=0; i<10; ++i)
		draw_edged_font(3, 20*i+30, text[i]);


	SDL_GL_SwapBuffers();
}



int main(int argc, char *argv[])
{
	FILE *in = fopen("testgl_kanji.txt", "r");
	if(in==0) return 0;
	for(int i=0; i<10; ++i)
		fgets(text[i], 128, in);
	fclose(in);
	for(int i=0; i<10; ++i) {
		for(int j=0; j<128; ++j)
			if(text[i][j]=='\r' || text[i][j]=='\n') text[i][j]='\0';
	}



	if( SDL_Init(SDL_INIT_TIMER | SDL_INIT_VIDEO | SDL_INIT_AUDIO | SDL_INIT_JOYSTICK )<0 ) { 
		printf("error at initializing SDL: %s.\n", SDL_GetError());
		exit(-1);
	}

	SDL_GL_SetAttribute( SDL_GL_RED_SIZE, 5 );
	SDL_GL_SetAttribute( SDL_GL_GREEN_SIZE, 5 );
	SDL_GL_SetAttribute( SDL_GL_BLUE_SIZE, 5 );
	SDL_GL_SetAttribute( SDL_GL_DEPTH_SIZE, 16 );
	SDL_GL_SetAttribute( SDL_GL_DOUBLEBUFFER, 1 );
	const SDL_VideoInfo *info = SDL_GetVideoInfo();
	int bpp = info->vfmt->BitsPerPixel;

	if( SDL_SetVideoMode( 400, 300, bpp, SDL_OPENGL ) == 0 ) {
		fprintf( stderr, "error at setting video mode: %s\n", SDL_GetError() );
		exit(-1);
	}


	kanji.load(text[0]);

	glShadeModel( GL_SMOOTH );
	glCullFace( GL_BACK );
	glFrontFace( GL_CCW );
	glEnable( GL_CULL_FACE );
	glClearColor( 0, 0, 0, 0 );

	glMatrixMode( GL_PROJECTION );
	glLoadIdentity( );
	gluPerspective( 60.0, 1.333, 1.0, 1024.0 );
	glMatrixMode( GL_MODELVIEW );
	glLoadIdentity( );

	while(1) {
		SDL_Event event;
		while( SDL_PollEvent(&event) ) {
			if( event.type==SDL_QUIT )
				return 0;
		}

		draw();
	}

	SDL_Quit();
}


